function [BP,BPno] = BPAP(BP,T,deltaT,PostTrain,IFBf,TauFBs,TauSBs)
%TauSBs = 25; %This is now set by the GUI
%IFBf = 0.75; %This is now set by the GUI

%This finds any post train activity at the time point
indexs = find(((PostTrain) == T+deltaT));


%TauFBs = 3; %This is now set by the GUI

%since ISBs + IFBf = 1 we can do the following.
ISBs = 1 - IFBf;

%convert time to correct interval
T= T/10;
deltaT = deltaT/10;


% right hand side of * always between 0 and 1, so this decays the previous level by the correct amount
BP = BP*((IFBf*exp(-deltaT/TauFBs))+ (ISBs*exp(-deltaT/TauSBs)));
BPno(1) = BP;
%BP = 0;

%This loops through all the activity and calculates their contribution to the BP.
for i = 1:length(indexs)
    %calculates the contribution
    add = ((IFBf * exp(-((T+deltaT)-(PostTrain(indexs(i)))/10)/TauFBs) + ISBs*exp(-((T+deltaT)-(PostTrain(indexs(i)))/10)/TauSBs)));
    %adds this contribution to the base line
    BP = BP + ((67)*(add));
    %puts the value into the array
    BPno(length(BPno)+1) = BP;

end
