function [EPSPs,BPAPs,V,Inmdas,Cad,Ca,Wd,W,Wturnaxis,Wturn] = Proc(WdInit,WInit,CadInit,CaInit,VInit,EPSPInit,BPAPinit... 
    ,InmdasInit,PreTrain,PostTrain,deltaT,inmdaTauF,inmdaTauS,inmdaVr,inmdaI_f,inmdaP0,BPAPIFBf,BPAPTauFBs,BPAPTauSBs,... 
    etaP1,etaP2div,etaP3,etaP4,Omegalpha1,Omegalpha2,Omegbeta1,Omegbeta2,CadtTauCa,Epsps,EpspTau1Ep,EpspTau2ep,Gnmda)
%The main fuction for the STDP model.

%clear all previous runs data
clear W Wd Ca Cad V EPSPs BPAPs Inmdas lastIndex i cap capac bp vp imp ep axisplot

%round all pre and post synaptic events in the two arrays
PreTrain = round(PreTrain)
PostTrain = round(PostTrain)

%find the last event (either post or pre)
lastIndex = max(max(PreTrain),max(PostTrain));

%Init variables
EPSPVr = 0;
EPSPnmda = -1;
Wturn(1) = WInit;
Wturnaxis(1) = 0;
Wd(1) = WdInit;
W(1) = WInit;
Cad(1) = CadInit;
Ca(1) = CaInit;
V(1) = VInit;
EPSPs = EPSPInit;
BPAPs(1) = BPAPinit;
Inmdas(1) = InmdasInit;
EPSPnmdas(1) = 0;
axisplot(1) = 0;
sat = 20;
nmda_norm = 0.4725;
nmda_s = 5;

%calculate the places where events occur either pre or post synatpically
stops = unique(cat(1,PreTrain,PostTrain))-1

%start a timer
tic

%init some more variables
steps = cell(1);
itsmax = 10000;
stepper = [];
flag = 0;

%loop through all the events (pre and post) creating seperate steps to
%proceed with. These are groups of events that occur close enough to each
%that they are calculate together. These steps are stored in the variable
%steps and used to process the data in blocks hence saving memory.
for j = 1:length(stops)-1

 %stepper is populated by going through each of elemets in stop, seeing if the next stop is more than its max away, if it isnt then
 %all of the places between them are added else upto itsmax are added....
    if (stops(j+1) - stops(j)) < itsmax
        display('norm');
        if flag == 0
             display('flag');
             stepper = [stops(j)-1];
             flag = 1;
        end
        stepper = cat(2,stepper,stops(j):stops(j+1)-1);
        stops(j)
        (stops(j+1)-1)
    else
        display('its');
        if flag == 0
             stepper = [stops(j)-1];
             flag = 1;
        end
        stepper = cat(2,stepper,stops(j):(stops(j)+itsmax));
        steps{length(steps)+1} = stepper;
        stepper = [];
        flag = 0;
    end
end


if(numel(stepper) ~= 0)
    steps{length(steps)+1} = stepper;
end
assignin('base', 'steps', steps)

%loop through all of the blocks in steps
for p = 2:length(steps)
    %get all events in this step
    stepper = steps{p};
    %save the location of the step for plotting
    axisplot(length(axisplot)+1) = stepper(1)-1;
    %print the length of the step
    length(stepper)
    %loop through each of the events in this step.
    for k = 1:length(stepper)-1
             i = stepper(k);
             %the time step is the distnace between steps
            deltaT = stepper(k+1)- stepper(k) ;
            if deltaT ~= 1
             deltaT
             i
            end
            
            %calculate the size of the store variables
            ep = size(EPSPs,1);
             vp = length(V);
             %add the event to the axis plot variable for plotting later
            axisplot(ep+1) = i;
            
            %calculate size of the varaible
            EPSPnmdalen = length(EPSPnmdas);
            %calculate the nmda component of the EPSP
            EPSPnmdas(EPSPnmdalen+1) = Inmda(i,PreTrain,deltaT,V(vp),inmdaTauF,inmdaTauS,EPSPVr,inmdaI_f,-0.0627353,1,0,0,EPSPnmdas(EPSPnmdalen));
            %store the values
            [EPSPs(ep+1,1),EPSPs(ep+1,2),EPSPs(ep+1,3),EPSPsno] = EPSP(EPSPs(ep,2),EPSPs(ep,3),i,deltaT,PreTrain,Epsps,EpspTau1Ep,EpspTau2ep,V(vp),EPSPs(ep,1),EPSPnmdas(EPSPnmdalen+1),nmda_norm,nmda_s);
            
            %calculate the size of the variable
            bp = length(BPAPs);
            %calculate the BPAP
            [BPAPs(bp+1),BPno] = BPAP(BPAPs(bp),i,deltaT,PostTrain,BPAPIFBf,BPAPTauFBs,BPAPTauSBs);
            %store the values
            V(vp+1) = V(1) + (EPSPs(ep+1,1)) + (BPAPs(bp+1));
            
            %calculate the size of the variable
            imp = length(Inmdas);
            %calculate the NMDA current and store the value
            Inmdas(imp+1) = Inmda(i,PreTrain,deltaT,V(vp+1),inmdaTauF,inmdaTauS,inmdaVr,inmdaI_f,inmdaP0,Gnmda,BPno,EPSPsno,Inmdas(imp));
            

            %calculate the length of the varaibles
            cap = length(Cad);
            capac = length(Ca);
            
            %calcualte the rate of change of the Ca
            Cad(cap+1) = dCaDt(Inmdas(imp+1),Ca(capac),CadtTauCa);
            %calculate the new calcium concentration
            tempCa = Ca(capac) + (1/10)*((Cad(cap) + Cad(cap+1))/2);
            Ca(capac+1) = tempCa;
            %if this was a peak on the 
            if(Cad(cap) > 0 && Cad(cap+1) < 0 )
                %calcualte how many entries there are in Wturn
                wl = length(Wturn);
                %calculate eta at time t
                teta = (eta(Ca(capac),etaP1,etaP2div,etaP3,etaP4));
                %calcualte omega at time t
                tomega = (Omega(Ca(capac),Omegalpha1,Omegalpha2,Omegbeta1,Omegbeta2));
                %combine the omega and eta
                temp = teta * tomega;
                %In order to saturate the weight change if tomega is
                %greater than 0 then the updated value is weighted by 1
                %over the previous value. This means that as the values get
                %higher the increase per unit decreses.
                if (tomega >= 0)
                       Wturn(wl+1) =  Wturn(wl) + ((1/Wturn(wl))*(temp));
                else
                Wturn(wl+1) =  Wturn(wl) + (Wturn(wl)*temp);    
                end
                %store the value of t for plotting
                Wturnaxis((wl+1)) = i;
            end
            %get the location of the end of the arrays
            wp = length(Wd);
            wpac = length(W);
            %The change in efficiency is then recalcualted here (this is
            %dusplicated because it was useful to be able to track the
            %input of eta and omega separtely and hence they are calcualted
            %and stored above. this could be improved!
            Wd(wp+1) = Wdot(Ca(capac+1),W(wpac),etaP1,etaP2div,etaP3,etaP4,Omegalpha1,Omegalpha2,Omegbeta1,Omegbeta2);
            W(wpac+1) = W(wpac) + (1)* ((Wd(wp) + Wd(wp+1))/2);   

    end
%this is the end of the loop for the model, what follows is memory
%alocation and plotting sections.

%once the step has come to an end the length of all of the arrays is
%calcualted and finished with a value.
            ep = size(EPSPs,1);
            axisplot(ep+1) = stepper(length(stepper))+1;
            EPSPs(ep+1,:)= EPSPInit;
            bp = length(BPAPs);
            BPAPs(bp+1) = BPAPinit;
            vp = length(V);
            V(vp+1) = VInit;
            enmda = length(EPSPnmdas);
            EPSPnmdas(enmda+1) = 0;
            imp = length(Inmdas);
            Inmdas(imp+1) = InmdasInit;
            cap = length(Cad);
            capac = length(Ca);
            Cad(cap+1) = CadInit;
            Ca(capac+1) = CaInit;
            wp = length(Wd);
            wpac = length(W);
            Wd(wp+1) = WdInit;
            W(wpac+1) = WInit; 
            
%the data is saved.
save(strcat('store',int2str(p)), 'W', 'Wd','Ca', 'Cad', 'V', 'EPSPs', 'BPAPs' ,'Inmdas','axisplot','EPSPnmdas')
%and then cleared
            clear W Wd Ca Cad V EPSPs BPAPs Inmdas axisplot EPSPnmdas
%they are then reinitialised for the next step.
Wd(1) = WdInit;
W(1) = WInit;
Cad(1) = CadInit;
Ca(1) = CaInit;
V(1) = VInit;
EPSPs = EPSPInit;
BPAPs(1) = BPAPinit;
Inmdas(1) = InmdasInit;
EPSPnmdas(1) = 0;
axisplot = [];
            
p            

%and the loop restarts
end 

%close(h) 

%the rest of all of this plots the data and commits the variables to the
%workspace so that you can look at them.
stuff = load('store2')
Wd = stuff.Wd;
W = stuff.W;
Cad = stuff.Cad;
Ca = stuff.Ca;
V = stuff.V;
EPSPs = (stuff.EPSPs)';
BPAPs = stuff.BPAPs;
Inmdas = stuff.Inmdas;
EPSPnmdas = stuff.EPSPnmdas;
axisplot = stuff.axisplot;
delete(strcat('store2','.mat'))
for p = 3:length(steps)
    p
    name = strcat('store',int2str(p));
    stuff = load(name);
    Wd = cat(2,Wd,stuff.Wd);
    W = cat(2,W,stuff.W);
    Cad = cat(2,Cad,stuff.Cad);
    Ca = cat(2,Ca,stuff.Ca);
    V = cat(2,V,stuff.V);
    EPSPs = cat(2,EPSPs,(stuff.EPSPs)');
    BPAPs = cat(2,BPAPs,stuff.BPAPs);
    Inmdas = cat(2,Inmdas,stuff.Inmdas);
    EPSPnmdas = cat(2,EPSPnmdas,stuff.EPSPnmdas);
    axisplot = cat(2,axisplot,stuff.axisplot);
    delete(strcat(name,'.mat'))
end
toc
assignin('base', 'axisplot', axisplot)
assignin('base', 'EPSPs', EPSPs)
assignin('base', 'BPAPs', BPAPs)
assignin('base', 'Inmdas', Inmdas)
assignin('base', 'EPSPnmdas', EPSPnmdas)
assignin('base', 'V', V)
assignin('base', 'Cad', Cad)
assignin('base', 'Ca', Ca)
assignin('base', 'W', W)
assignin('base', 'Wd', Wd)
assignin('base', 'Wturn', Wturn)
assignin('base', 'Wturnaxis', Wturnaxis)

figure
plot(axisplot,EPSPnmdas,'r')
hold on
plot(axisplot,EPSPs(1,:))
plot(axisplot,(EPSPs(1,:)-EPSPnmdas),'g')
hold off

figure
subplot(6,1,1); 
plot(axisplot,EPSPnmdas,'r')
hold on
plot(axisplot,EPSPs(1,:))
hold off
xlabel('time (1/10000s)')
ylabel('Voltage (mV)')
title('EPSPs at the pre synaptic synapse')
subplot(6,1,2); plot(axisplot,BPAPs)
xlabel('time (1/10000s)')
ylabel('Voltage (mV)')
title('BPAPs at the post synaptic synapse')
subplot(6,1,3); plot(axisplot,V)
xlabel('time (1/10000s)')
ylabel('Voltage (mV)')
title('Membrane potential of the post synaptic synapse')
subplot(6,1,4); plot(axisplot,Inmdas)
xlabel('time (1/10000s)')
ylabel('Current')
title('Calcium current through the NMDA receptors')
subplot(6,1,5); plot(axisplot,Ca)
xlabel('time (1/10000s)')
ylabel('Concentration (micromol)')
title('Calcium concentration in the post synaptic terminal')
subplot(6,1,6); plot(Wturnaxis,Wturn)
xlabel('time (1/10000s)')
ylabel('Synaptic Strength')
title('Synaptic strength between pren and post synaptic terminals')
linkzoom

