function [pretrain,posttrain] = trainFunc(pairings,frequency,preT,postT)

%It is important that the preT and postT array has one entry which should
%be zero for pre and the deltaT for post.

%The pairings variable sets the number of pairings to use
%the frequency variable sets the frequency between pairings
%The Pret and PostT varables are vecotrs of lags

%example usage might be [posttrain,pretrain] = trainFunc(10,1000,[0,100],[0])
%this would create posttrain as vector of 10 spikes with two spikes every 1000, one on
%1000 and one with a 100 lag. pretrain would just be a vector of 10 spikes every 1000.

%allocates memory

pretrain = zeros(((numel(preT)*pairings)),1);
posttrain = zeros(((numel(postT)*pairings)),1);
%initiate first point
%posttrain(1,1) = ;
%pretrain(1,1) = ;

preC = 1;
postC = 1;
for i = 1:pairings
    %this loops through alll the required pairings
    for j = 1:length(preT)
        %this adds to the pretrain all of the preSynaptic entries
        pretrain(preC,1) =  ((i*((1/frequency)))+preT(j))*10000;
        preC = preC + 1;
    end
    for k = 1:length(postT)
        %this adds to the posttrain all of the postSynpatic entries
        posttrain(postC,1) =  ((i*((1/frequency)))+postT(k))*10000;
        postC = postC + 1;
    end
end
posttrain(postC,1) = posttrain(postC-1,1)+10000;
pretrain(preC,1) = pretrain(preC-1,1)+10000;